﻿using System;
using System.Data;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Infragistics.Web.UI.GridControls;
using Infragistics.Web.UI.ListControls;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        this.WebHierarchicalDataGrid1.DataSource = GetData();
        this.WebHierarchicalDataGrid1.DataBind();
    }

    #region Creating DataSet for the grid

    public DataSet GetData()
    {
        DataSet ds = new DataSet("Set");
        ds.Tables.Add(GetParentData());
        ds.Tables.Add(GetChildData1());
        ds.Tables.Add(GetChildData2());
        ds.Relations.Add(
            ds.Tables["ParentTable"].Columns["Claim Number"],
            ds.Tables["ChildTable"].Columns["Claim Number"]);
        ds.Relations.Add(
            ds.Tables["ChildTable"].Columns["DCN"],
            ds.Tables["ChildTable2"].Columns["DCN"]);
        return ds;
    }

    public DataTable GetParentData()
    {
        DataTable table = new DataTable("ParentTable");
        table.Columns.Add("Claim Number", typeof(string));
        table.Columns.Add("Patient Last Name", typeof(string));
        table.Columns.Add("Patient First Name", typeof(string));
        table.Columns.Add("SSN", typeof(string));
        table.Columns.Add("Injury Date", typeof(DateTime));
        for (int i = 0; i < 2; i++)
        {
            table.Rows.Add("CLM12345678" + i, "Sear", "Pat", "123456789", DateTime.Now.AddDays(-1000));
        }
        table.PrimaryKey = new DataColumn[] { table.Columns["Claim Number"] };
        return table;
    }

    public DataTable GetChildData1()
    {
        DataTable table = new DataTable("ChildTable");
        table.Columns.Add("DCN", typeof(string));
        table.Columns.Add("Claim Number", typeof(string));
        table.Columns.Add("Value", typeof(string));
        table.Columns.Add("Service Date", typeof(DateTime));
        table.Columns.Add("Reject Code", typeof(string));
        table.Columns.Add("Internal Control Number", typeof(string));
        table.Columns.Add("FTIN", typeof(string));
        table.Columns.Add("Provider Name", typeof(string));
        table.Columns.Add("OCT Status", typeof(string));
        table.Columns.Add("Bill Review Status", typeof(string));
        for (int i = 0; i < 2; i++)
        {
            for (int j = 0; j < 3; j++)
            {
                table.Rows.Add("DCN12345678" + i + j, "CLM12345678" + i, "7361", DateTime.Now.AddDays(-999), "", "26070950599400", "488403658", "MCCARROLL JR H RELTON", "", "Get Status");
            }
        }
        table.PrimaryKey = new DataColumn[] { table.Columns["DCN"] };
        return table;
    }

    public DataTable GetChildData2()
    {
        DataTable table = new DataTable("ChildTable2");
        table.Columns.Add("Pages", typeof(string));
        table.Columns.Add("DCN", typeof(string));
        for (int j = 0; j < 3; j++)
        {
            for (int k = 0; k < 2; k++)
            {
                if (k == 0)
                {
                    table.Rows.Add("MEDICAL BILL - CMS-1500, UB...", "DCN12345678" + k + j);
                    table.Rows.Add("FH EOR", "DCN12345678" + k + j);
                }
                else
                {
                    table.Rows.Add("MEDICAL BILL - CMS-1500, UB...", "DCN12345678" + k + j);
                    table.Rows.Add("FH EOR", "DCN12345678" + k + j);
                }
            }
        }
        table.PrimaryKey = new DataColumn[] { table.Columns["Pages"], table.Columns["DCN"] };
        return table;
    }
    #endregion

    // dataTable to populate the second dropdown
    protected DataTable populateList()
    {
        DataTable dt = new DataTable();
        dt.Columns.Add("value");
        dt.Columns.Add("description");
        DataRow row;
        for (int i = 0; i < 10; i++)
        {
            row = dt.NewRow();
            row.SetField<Int32>("value", i);
            row.SetField<string>("description", "Text" + i);
            dt.Rows.Add(row);
        }

        return dt;
    }

    private DataTable MakeTable(int x)
    {
        // Create a new DataTable.
        System.Data.DataTable table = new DataTable("Table");
        // Declare variables for DataColumn and DataRow objects.
        DataColumn column;
        DataRow row;

        // Create new DataColumn, set DataType, 
        // ColumnName and add to DataTable.    
        column = new DataColumn();
        column.DataType = System.Type.GetType("System.Int32");
        column.ColumnName = "id";
        column.ReadOnly = true;
        // Add the Column to the DataColumnCollection.
        table.Columns.Add(column);

        // Create second column.
        column = new DataColumn();
        column.DataType = System.Type.GetType("System.Int32");
        column.ColumnName = "Item";
        column.AutoIncrement = false;
        column.Caption = "Item";
        column.ReadOnly = false;
        column.Unique = false;
        // Add the column to the table. 
        table.Columns.Add(column);

        // Create third column.
        column = new DataColumn();
        column.DataType = System.Type.GetType("System.String");
        column.ColumnName = "Data";
        column.AutoIncrement = false;
        column.Caption = "Data";
        column.ReadOnly = false;
        column.Unique = false;
        // Add the column to the table.
        table.Columns.Add(column);

        // Make the ID column the primary key column.
        DataColumn[] PrimaryKeyColumns = new DataColumn[1];
        PrimaryKeyColumns[0] = table.Columns["id"];
        table.PrimaryKey = PrimaryKeyColumns;

        if (x == 0)
        {
            for (int i = 0; i <= 20; i++)
            {
                row = table.NewRow();
                row["id"] = i;
                row["Item"] = i;
                row["Data"] = "Data " + i;
                table.Rows.Add(row);
            }
        }
        if (x == 1)
        {
            for (int i = 0; i <= 5; i++)
            {
                row = table.NewRow();
                row["id"] = i;
                row["Item"] = i;
                row["Data"] = "Data " + i;
                table.Rows.Add(row);
            }
        }

        return table;
    }

    protected void ddeditor1_ItemsRequested(object sender, EventArgs e)
    {
        int rowIndex = Int32.Parse(((Infragistics.Web.UI.ListControls.DropDownItemsRequestedEventArgs)e).Value.ToString());
       
        // query your database using the rowIndex value, or assign datasource, or filter current dataSource, etc
        this.dd2.EditorControl.DataSource = MakeTable(rowIndex);
        this.dd2.EditorControl.ValueField = "id";
        this.dd2.EditorControl.TextField = "Data";
        this.dd2.EditorControl.DataBind();

    }
}